/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Blowfish.xs. Do not edit this file, edit Blowfish.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Blowfish.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_mg_findext
#include "ppport.h"

#include <openssl/blowfish.h>
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
#include <openssl/evp.h>
#include <openssl/provider.h>
#endif

/*==========================================================*/
/*                                                          */
/* hexdump.xs:                                              */
/* https://gist.github.com/mcnewton/14322391d50240ec9ebf    */
/*                                                          */
/* Matthew Newton @mcnewton                                 */
/* See hexdump.xs for LICENSE information                   */
/*==========================================================*/

#ifdef INCLUDE_HEXDUMP
#include "hexdump.xs"
#endif

/*==================================================*/
/*                                                  */
/* Macro to swap from little endian to big endian   */
/*                                                  */
/*==================================================*/
# undef n2l
# define n2l(c,l)        (l =((unsigned long)(*((c)++)))<<24L, \
                         l|=((unsigned long)(*((c)++)))<<16L, \
                         l|=((unsigned long)(*((c)++)))<< 8L, \
                         l|=((unsigned long)(*((c)++))))

/*==================================================*/
/*                                                  */
/* Macro to swap from big endian to little endian   */
/*                                                  */
/*==================================================*/
# undef l2n
# define l2n(l,c)        (*((c)++)=(unsigned char)(((l)>>24L)&0xff), \
                         *((c)++)=(unsigned char)(((l)>>16L)&0xff), \
                         *((c)++)=(unsigned char)(((l)>> 8L)&0xff), \
                         *((c)++)=(unsigned char)(((l)     )&0xff))

/*============================================*/
/*                                            */
/* ensure_hv(SV *sv, const char *identifier)  */
/*                                            */
/* Helper function Taken from p5-Git-Raw      */
/* to ensure that a value is a hash.  It is   */
/* used to verify that the 'options' passed   */
/* in the constructor is valid                */
/*                                            */
/*============================================*/
STATIC HV *ensure_hv(pTHX_ SV *sv, const char *identifier) {
    if (!SvROK(sv) || SvTYPE(SvRV(sv)) != SVt_PVHV)
    croak("Invalid type for '%s', expected a hash", identifier);

    return (HV *) SvRV(sv);
}

/*======================================================================*/
/*                                                                      */
/* big_endian(const unsigned char *in, unsigned char *out)              */
/*                                                                      */
/* Swap the endianness of the block of data 'in'.  This is only         */
/* required for compatability with the original version of              */
/* Crypt::OpenSSL::Blowfish.  Which calls BF_encrypt and BF_decrypt     */
/* without switching to big endian first.  This function is called if   */
/* Crypt::OpenSSL::Blowfish is created without any options (other than  */
/* the key).                                                            */
/*                                                                      */
/*======================================================================*/
void big_endian(const unsigned char *in, unsigned char *out)
{
    BF_LONG l;
    BF_LONG d[2];

    n2l(in, l);
    d[0] = l;
    n2l(in, l);
    d[1] = l;
    Copy(d, out, 2, BF_LONG);
    l = d[0] = d[1] = 0;
}

/*======================================================================*/
/*                                                                      */
/* return_big_endian(const unsigned char *in)                           */
/*                                                                      */
/* Swap the endianness of the block of data 'in'.  This is only         */
/* required for compatability with the original version of              */
/* Crypt::OpenSSL::Blowfish.  Which calls BF_encrypt and BF_decrypt     */
/* without switching to big endian first.  This function is called if   */
/* Crypt::OpenSSL::Blowfish is created without any options (other than  */
/* the key) or if the Modules get_big_endian is called.                 */
/*                                                                      */
/*======================================================================*/
unsigned char * return_big_endian(pTHX_ const unsigned char *in)
{
    unsigned char * out;
    Newx(out, BF_BLOCK, unsigned char); //Bunsigned char, unsigned char);
    big_endian(in, out);
    return out;
}

/*======================================================================*/
/*                                                                      */
/* little_endian(const BF_LONG *d, unsigned char *out)                  */
/*                                                                      */
/* Swap the endianness of the block of data 'in'.  This is only         */
/* required for compatability with the original version of              */
/* Crypt::OpenSSL::Blowfish.  Which calls BF_encrypt and BF_decrypt     */
/* without switching to big endian first.  This function is called if   */
/* Crypt::OpenSSL::Blowfish is created without any options (other than  */
/* the key).                                                            */
/*                                                                      */
/*======================================================================*/
void little_endian(const BF_LONG *in, unsigned char *out)
{
    BF_LONG l;

    l = in[0];
    l2n(l, out);
    l = in[1];
    l2n(l, out);
}

/*======================================================================*/
/*                                                                      */
/* return_little_endian(const unsigned char *in)                        */
/*                                                                      */
/* Swap the endianness of the block of data 'in'.  This is only         */
/* required for compatability with the original version of              */
/* Crypt::OpenSSL::Blowfish.  Which calls BF_encrypt and BF_decrypt     */
/* without switching to big endian first.  This function is called if   */
/* Crypt::OpenSSL::Blowfish is created without any options (other than  */
/* the key) or if the Modules get_big_endian is called.                 */
/*                                                                      */
/*======================================================================*/
unsigned char * return_little_endian(pTHX_ unsigned char *in)
{
    unsigned char *out;
    BF_LONG d[2];

    Newx(out, BF_BLOCK, unsigned char);
    Copy(in, d, BF_BLOCK, unsigned char);

    little_endian(d, out);

    return out;
}

void print_pointers(pTHX_ char * name, void * pointer) {
#ifdef PRINT_POINTERS
    printf("Crypt pointer - %s: %p\n", name, pointer);
    printf("Crypt INT of pointer - %s: %lu\n", name, (unsigned long) PTR2IV(pointer));
#endif
}

static const MGVTBL ks_magic = { NULL, NULL, NULL, NULL, NULL };

#line 177 "Blowfish.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 321 "Blowfish.c"

XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "class, key_sv, ...");
    {
	const char *	class = (const char *)SvPV_nolen(ST(0))
;
	SV *	key_sv = ST(1)
;
#line 183 "Blowfish.xs"
        SV *ks = newSV(0);
        IV mod = 1;
        STRLEN keysize;
        unsigned char * key;
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
        EVP_CIPHER_CTX *ctx = NULL;
        OSSL_PROVIDER *legacy;
        OSSL_PROVIDER *deflt;
#else
        BF_KEY *bf_ks;
#endif
        HV * options = NULL;
        HV * attributes;
        SV *modern = newSV(0);
#line 349 "Blowfish.c"
	SV *	RETVAL;
#line 198 "Blowfish.xs"
    {
        PERL_UNUSED_ARG(options);
        options = newHV();
        if (items > 2)
            options = ensure_hv(aTHX_ ST(2), "options");

        if (!SvPOK (key_sv))
            croak("Key must be a scalar");

        key     = (unsigned char *) SvPVbyte(key_sv, keysize);

        /* FIXME: openssl seems to use 16-byte keys only */
        if (keysize != 8 && keysize !=16 && keysize != 24 && keysize != 32)
            croak ("The key must be 64, 128, 192 or 256 bits long");
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
        legacy = OSSL_PROVIDER_load(NULL, "legacy");
        if (legacy == NULL) {
            croak("Failed to load Legacy provider\n");
        }

        deflt = OSSL_PROVIDER_load(NULL, "default");
        if (deflt == NULL) {
            OSSL_PROVIDER_unload(legacy);
            croak("Failed to load Default provider\n");
        }

        /* Create the EVP_CIPHER_CTX object */
        if(!(ctx = EVP_CIPHER_CTX_new()))
            croak ("Failed to create the EVP_CIPHER_CTX object\n");

        if(0 == EVP_CipherInit_ex2(ctx, EVP_bf_ecb(), NULL, NULL, 0, NULL))
            croak ("EVP_CipherInit_ex2 failed\n");

        EVP_CIPHER_CTX_set_key_length(ctx, keysize);
        /*hexdump(stdout, (unsigned char *) ctx, sizeof(ctx), 16, 8); */
        OPENSSL_assert(EVP_CIPHER_CTX_key_length(ctx) == keysize);
        OPENSSL_assert(EVP_CIPHER_CTX_iv_length(ctx) == 0); /*FIXME */

        if (0 == EVP_CipherInit_ex2(ctx, NULL, key, NULL, 0, NULL))
            croak ("EVP_CipherInit_ex2 failed\n");

        /*hexdump(stdout, (unsigned char *) ctx, sizeof(ctx), 16, 8); */
        print_pointers(aTHX_ "ctx", ctx);
#else
        /* Allocate memory to hold the Blowfish BF_KEY object */
        Newx(bf_ks, 1, BF_KEY);

        BF_set_key(bf_ks, keysize, key);

        print_pointers(aTHX_ "bf_ks", bf_ks);
#endif
        attributes = newHV();
        SV *const self = newRV_inc( (SV *)attributes );
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
        sv_magicext(ks, NULL, PERL_MAGIC_ext,
            &ks_magic, (const char *) ctx, 0);
#else
        sv_magicext(ks, NULL, PERL_MAGIC_ext,
            &ks_magic, (const char *) bf_ks, 0);
#endif
        if((hv_store(attributes, "ks", 2, ks, 0)) == NULL)
            croak("unable to store the BF_KEY");

        if (items > 2) {
            sv_magicext(modern, NULL, PERL_MAGIC_ext,
                &ks_magic, (const char *) mod, 0);

            if((hv_store(attributes, "modern", 6, modern, 0)) == NULL)
                croak("unable to store the modern");
        }

        print_pointers(aTHX_ "modern", modern);
        RETVAL = sv_bless( self, gv_stashpv( class, 0 ) );
    }
#line 426 "Blowfish.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_crypt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, data_sv, encrypt");
    {
	HV *	self;
	SV *	data_sv = ST(1)
;
	int	encrypt = (int)SvIV(ST(2))
;
#line 287 "Blowfish.xs"
        STRLEN data_len;
        unsigned char * in;
        MAGIC* mg;
        SV **svp;
        int *modern = 0;
        unsigned char *out;
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
        EVP_CIPHER_CTX *ctx;
        int out_len = 0;
        int ciphertext_len = 0;
        int plaintext_len = 0;
#else
        BF_KEY *bf_ks = NULL;
#endif
#line 461 "Blowfish.c"
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Crypt::OpenSSL::Blowfish::crypt",
				"self");
		}
	} STMT_END
;
#line 302 "Blowfish.xs"
    {
        if (hv_exists(self, "modern", strlen("modern"))) {
            svp = hv_fetch(self, "modern", strlen("modern"), 0);
            if (!SvMAGICAL(*svp) || (mg = mg_findext(*svp, PERL_MAGIC_ext, &ks_magic)) == NULL)
                croak("Accessing the modern value from magic failed");
            modern = (int *) mg->mg_ptr;
        }

        in = (unsigned char *) SvPVbyte(data_sv, data_len);

        /*hexdump(stdout, data, data_len, 16, 8); */

        Newx(out, BF_BLOCK, unsigned char);
        if (! modern) {
            Copy(in, out, BF_BLOCK, unsigned char);
            in = return_big_endian(aTHX_ out);
        }

        /*hexdump(stdout, data, data_len, 16, 8); */
        if (!hv_exists(self, "ks", strlen("ks")))
            croak("ks not found in self!\n");

        svp = hv_fetch(self, "ks", strlen("ks"), 0);

        if (!SvMAGICAL(*svp) || (mg = mg_findext(*svp, PERL_MAGIC_ext, &ks_magic)) == NULL)
            croak("Accessing the key from magic failed");
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
        ctx = (EVP_CIPHER_CTX *) mg->mg_ptr;
        print_pointers(aTHX_ "ctx", ctx);

        if ( encrypt == 1) {
            EVP_CIPHER_CTX_set_padding(ctx, 0);
            if (0 == EVP_CipherInit_ex2(ctx, NULL, NULL, NULL, encrypt, NULL))
                croak("EVP_CipherInit_ex2 failed");

            if (0 == EVP_CipherUpdate(ctx, out, &out_len, in, data_len))
                croak ("EVP_CipherUpdate failed in Encrypt\n");

            ciphertext_len += out_len;

            if (0 == EVP_CipherFinal_ex(ctx, out + out_len, &out_len))
                croak ("EVP_CipherFinal_ex failed in Encrypt\n");

            ciphertext_len += out_len;

            /*hexdump(stdout, (unsigned char *) out, sizeof(out), 16, 8); */
        } else {
            print_pointers(aTHX_ "ctx", ctx);
            /*hexdump(stdout, (unsigned char *) data, sizeof(data), 16, 8); */
            EVP_CIPHER_CTX_set_padding(ctx, 0);
            if (0 == EVP_CipherInit_ex2(ctx, NULL, NULL, NULL, encrypt, NULL))
                croak(">>>EVP_CipherInit_ex2 failed");

            /*hexdump(stdout, (unsigned char *) ctx, sizeof(ctx), 16, 8); */
            if (0 == EVP_CipherUpdate(ctx, out, &out_len, in, data_len))
                croak ("EVP_CipherUpdate failed in Decrypt\n");

            /*hexdump(stdout, (unsigned char *) ciphertext, sizeof(plaintext), 16, 8); */
            plaintext_len += out_len;

            if (0 == EVP_CipherFinal_ex(ctx, out + out_len, &out_len))
                croak ("EVP_CipherFinal_ex failed in Decrypt\n");

            plaintext_len += out_len;
            /*hexdump(stdout, (unsigned char *) plaintext, sizeof(plaintext), 16, 8); */
        }
#else
        bf_ks = (BF_KEY *) mg->mg_ptr;
        print_pointers(aTHX_ "bf_ks", bf_ks);

        /*hexdump(stdout, bf_ks, sizeof(BF_KEY), 16, 8); */
        if (data_len != BF_BLOCK) {
            croak("data must be 8 bytes long");
        }

        BF_ecb_encrypt(in, out, bf_ks, encrypt);
#endif
        /*hexdump(stdout, out, sizeof(char)*8, 16, 8); */

        if (! modern) {
            Copy(out, in, BF_BLOCK, unsigned char );
            out = return_little_endian(aTHX_ in);
        }

        /*hexdump(stdout, out, sizeof(char)*8, 16, 8); */

        RETVAL = newSV (data_len);
        SvPOK_only (RETVAL);
        SvCUR_set (RETVAL, data_len);
        sv_setpvn(RETVAL, (char *) out, data_len);

    }
#line 570 "Blowfish.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_get_big_endian); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_get_big_endian)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data_sv");
    {
	HV *	self;
	SV *	data_sv = ST(1)
;
#line 409 "Blowfish.xs"
        unsigned char * in;
        unsigned char * out;
        STRLEN data_len;
#line 592 "Blowfish.c"
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Crypt::OpenSSL::Blowfish::get_big_endian",
				"self");
		}
	} STMT_END
;
#line 413 "Blowfish.xs"
        PERL_UNUSED_ARG(self);
        in = (unsigned char *) SvPVbyte(data_sv, data_len);
        out = return_big_endian(aTHX_ in);

        RETVAL = newSV (data_len);
        SvPOK_only (RETVAL);
        SvCUR_set (RETVAL, data_len);
        sv_setpvn(RETVAL, (char *) out, data_len);
#line 617 "Blowfish.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_get_little_endian); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_get_little_endian)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data_sv");
    {
	HV *	self;
	SV *	data_sv = ST(1)
;
#line 436 "Blowfish.xs"
        unsigned char *in;
        unsigned char *out;
        STRLEN data_len;
#line 639 "Blowfish.c"
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Crypt::OpenSSL::Blowfish::get_little_endian",
				"self");
		}
	} STMT_END
;
#line 440 "Blowfish.xs"
        PERL_UNUSED_ARG(self);
        in = (unsigned char *) SvPVbyte(data_sv, data_len);
        out = return_little_endian(aTHX_ in);

        RETVAL = newSV (data_len);
        SvPOK_only (RETVAL);
        SvCUR_set (RETVAL, data_len);
        sv_setpvn(RETVAL, (char *) out, data_len);
#line 664 "Blowfish.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Blowfish_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV *	self;
#line 462 "Blowfish.xs"
    SV **svp;
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
    EVP_CIPHER_CTX *ctx = NULL;
#else
    BF_KEY *bf_ks = NULL;
#endif
    MAGIC* mg;
    MAGIC* mg_mod;
    int * modern = NULL;
#line 690 "Blowfish.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Crypt::OpenSSL::Blowfish::DESTROY",
				"self");
		}
	} STMT_END
;
#line 472 "Blowfish.xs"
    if (!hv_exists(self, "ks", strlen("ks")))
        croak("ks not found in self!\n");

    svp = hv_fetch(self, "ks", strlen("ks"), 0);

    if (!SvMAGICAL(*svp) || (mg = mg_findext(*svp, PERL_MAGIC_ext, &ks_magic)) == NULL)
        croak("STORE is invalid");
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
    ctx = (EVP_CIPHER_CTX *) mg->mg_ptr;
    print_pointers(aTHX_ "ctx", ctx);

    if (!hv_exists(self, "modern", strlen("modern")))
        croak("modern not found in self!\n");

    svp = hv_fetch(self, "modern", strlen("modern"), 0);

    if (!SvMAGICAL(*svp) || (mg_mod = mg_findext(*svp, PERL_MAGIC_ext, &ks_magic)) == NULL)
    modern = (int *) mg_mod->mg_ptr;
    print_pointers(aTHX_ "modern", modern);
    /* Clean up */
    EVP_CIPHER_CTX_free(ctx);
    Safefree(modern);
#else
    bf_ks = (BF_KEY *) mg->mg_ptr;
    print_pointers(aTHX_ "bf_ks", bf_ks);
    Safefree(bf_ks);
#endif
#line 733 "Blowfish.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Crypt__OpenSSL__Blowfish); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__OpenSSL__Blowfish)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Crypt::OpenSSL::Blowfish::new", XS_Crypt__OpenSSL__Blowfish_new);
        newXS_deffile("Crypt::OpenSSL::Blowfish::crypt", XS_Crypt__OpenSSL__Blowfish_crypt);
        newXS_deffile("Crypt::OpenSSL::Blowfish::get_big_endian", XS_Crypt__OpenSSL__Blowfish_get_big_endian);
        newXS_deffile("Crypt::OpenSSL::Blowfish::get_little_endian", XS_Crypt__OpenSSL__Blowfish_get_little_endian);
        newXS_deffile("Crypt::OpenSSL::Blowfish::DESTROY", XS_Crypt__OpenSSL__Blowfish_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
